| Home · All Classes · All Namespaces · Modules · Functions · Files

Public Slots | Signals | Public Member Functions | List of all members
Tp::Service::ConnectionInterfaceContactBlockingAdaptor Class Reference
Service-side implementation » Connection service implementation

`#include <TelepathyQt/_gen/svc-connection.h>`

Inheritance diagram for Tp::Service::ConnectionInterfaceContactBlockingAdaptor:
[legend]

## Public Slots

void | BlockContacts (const Tp::UIntList &contacts, bool reportAbusive, const QDBusMessage &dbusMessage)
void | UnblockContacts (const Tp::UIntList &contacts, const QDBusMessage &dbusMessage)
Tp::HandleIdentifierMap | RequestBlockedContacts (const QDBusMessage &dbusMessage)

## Signals

void | BlockedContactsChanged (const Tp::HandleIdentifierMap &blockedContacts, const Tp::HandleIdentifierMap &unblockedContacts)

## Public Member Functions

uint | ContactBlockingCapabilities () const
Public Member Functions inherited from Tp::AbstractAdaptor
| AbstractAdaptor (const QDBusConnection &connection, QObject *adaptee, QObject *parent)
| ~AbstractAdaptor ()
QDBusConnection | dbusConnection () const
QObject * | adaptee () const
Public Member Functions inherited from QDBusAbstractAdaptor
| ~QDBusAbstractAdaptor ()
Public Member Functions inherited from QObject
| QObject (QObject *parent)
virtual | ~QObject ()
virtual bool | event (QEvent *e)
virtual bool | eventFilter (QObject *watched, QEvent *event)
virtual const QMetaObject * | metaObject () const
QString | objectName () const
void | setObjectName (const QString &name)
bool | isWidgetType () const
bool | signalsBlocked () const
bool | blockSignals (bool block)
QThread * | thread () const
void | moveToThread (QThread *targetThread)
int | startTimer (int interval)
void | killTimer (int id)
T | findChild (const QString &name) const
QList< T > | findChildren (const QString &name) const
QList< T > | findChildren (const QRegExp &regExp) const
QObject * | child (const char *objName, const char *inheritsClass, bool recursiveSearch) const
const QObjectList & | children () const
void | setParent (QObject *parent)
void | installEventFilter (QObject *filterObj)
void | removeEventFilter (QObject *obj)
bool | connect (const QObject *sender, const char *signal, const char *method, Qt::ConnectionType type) const
bool | disconnect (const char *signal, const QObject *receiver, const char *method)
bool | disconnect (const QObject *receiver, const char *method)
void | dumpObjectTree ()
void | dumpObjectInfo ()
bool | setProperty (const char *name, const QVariant &value)
QVariant | property (const char *name) const
QList< QByteArray > | dynamicPropertyNames () const
void | destroyed (QObject *obj)
QObject * | parent () const
bool | inherits (const char *className) const
void | deleteLater ()
| QObject (QObject *parent, const char *name)
void | insertChild (QObject *object)
void | removeChild (QObject *object)
bool | isA (const char *className) const
const char * | className () const
const char * | name () const
const char * | name (const char *defaultName) const
void | setName (const char *name)

## Additional Inherited Members

Static Public Member Functions inherited from QObject
QString | tr (const char *sourceText, const char *disambiguation, int n)
QString | trUtf8 (const char *sourceText, const char *disambiguation, int n)
bool | connect (const QObject *sender, const char *signal, const QObject *receiver, const char *method, Qt::ConnectionType type)
bool | connect (const QObject *sender, const QMetaMethod &signal, const QObject *receiver, const QMetaMethod &method, Qt::ConnectionType type)
bool | disconnect (const QObject *sender, const char *signal, const QObject *receiver, const char *method)
bool | disconnect (const QObject *sender, const QMetaMethod &signal, const QObject *receiver, const QMetaMethod &method)
Protected Member Functions inherited from QDBusAbstractAdaptor
| QDBusAbstractAdaptor (QObject *obj)
void | setAutoRelaySignals (bool enable)
bool | autoRelaySignals () const
Protected Member Functions inherited from QObject
QObject * | sender () const
int | senderSignalIndex () const
int | receivers (const char *signal) const
virtual void | timerEvent (QTimerEvent *event)
virtual void | childEvent (QChildEvent *event)
virtual void | customEvent (QEvent *event)
virtual void | connectNotify (const char *signal)
virtual void | disconnectNotify (const char *signal)
bool | checkConnectArgs (const char *signal, const QObject *object, const char *method)
Static Protected Member Functions inherited from QObject
QByteArray | normalizeSignalSlot (const char *signalSlot)
Properties inherited from QObject
| objectName

## Detailed Description

Adaptor class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.Connection.Interface.ContactBlocking".

## Member Function Documentation

## § ContactBlockingCapabilities()

uint Tp::Service::ConnectionInterfaceContactBlockingAdaptor::ContactBlockingCapabilities | ( |  | ) | const

Return the value of the exported D-Bus object property `ContactBlockingCapabilities` of type `uint`.

Adaptees should export this property as a Qt property named 'contactBlockingCapabilities' with type uint.

Additional capabilities for contact blocking; currently, this is limited to whether contacts may be reported as abusive.

Note that there is no capability for supporting blocking itself: the presence of this interface on a ConnectionInterface indicates that blocking contacts is supported.

Returns
  The value of exported property `ContactBlockingCapabilities`.

## § BlockContacts

void Tp::Service::ConnectionInterfaceContactBlockingAdaptor::BlockContacts | ( | const Tp::UIntList & | contacts,
|  | bool | reportAbusive,
|  | const QDBusMessage & | dbusMessage
| ) |  |

slot

Begins a call to the exported D-Bus method `BlockContacts` on this object.

Adaptees should export this method as a Qt slot with the following signature: void blockContacts(const Tp::UIntList& contacts, bool reportAbusive, const Tp::Service::ConnectionInterfaceContactBlockingAdaptor::BlockContactsContextPtr &context);

Implementations should call MethodInvocationContext::setFinished (or setFinishedWithError accordingly) on the received context object once the method has finished processing.

Direct the server to block some contacts. The precise effect is protocol-dependent, but SHOULD include ignoring all current and subsequent communications from the given contacts, avoiding sending presence to them in future, and if they were already receiving the local user's presence, behaving as if the local user went offline.

Parameters

  contacts

      Some contacts to block. If some of the contacts in this list are
      already blocked, the connection manager MUST act as if they were
      not specified in this list.

  reportAbusive

  In addition to blocking, report these contacts as abusive to the server administrators.

  Clients can determine whether this capability is available by checking the \\\ \\link requestPropertyContactBlockingCapabilities() ContactBlockingCapabilities \\endlink \\htmlonly property. If this argument is set to `True` by a client despite \\endhtmlonly \\link requestPropertyContactBlockingCapabilities() ContactBlockingCapabilities \\endlink \\htmlonly not containing the `Can_Report_Abusive` flag, the connection manager SHOULD act as if it were `False` and simply block the supplied contacts.

A correct user interface shouldn't get this far without knowing that reporting abusive contacts is not supported. If it does, then the user has expressed their intention to block these contacts. Returning an error would leave the UI with three options:

- Ignore the error, leaving the contacts not actually blocked;
- Display an error to the user;
- Call this method again, passing `False` for this argument.

None of these seem preferable to the CM just ignoring this flag if it doesn't support it: that way, the contacts will be blocked, as the user requested, and UIs have fewer ways to mess up entirely.

## § UnblockContacts

void Tp::Service::ConnectionInterfaceContactBlockingAdaptor::UnblockContacts | ( | const Tp::UIntList & | contacts,
|  | const QDBusMessage & | dbusMessage
| ) |  |

slot

Begins a call to the exported D-Bus method `UnblockContacts` on this object.

Adaptees should export this method as a Qt slot with the following signature: void unblockContacts(const Tp::UIntList& contacts, const Tp::Service::ConnectionInterfaceContactBlockingAdaptor::UnblockContactsContextPtr &context);

Implementations should call MethodInvocationContext::setFinished (or setFinishedWithError accordingly) on the received context object once the method has finished processing.

Direct the server to unblock some contacts.

Parameters

  contacts

      Some contacts to unblock. If some of the contacts in this list are
      not currently blocked, the connection manager MUST act as if they
      were not specified in this list.

## § RequestBlockedContacts

Tp::HandleIdentifierMap Tp::Service::ConnectionInterfaceContactBlockingAdaptor::RequestBlockedContacts | ( | const QDBusMessage & | dbusMessage | ) |

slot

Begins a call to the exported D-Bus method `RequestBlockedContacts` on this object.

Adaptees should export this method as a Qt slot with the following signature: void requestBlockedContacts(const Tp::Service::ConnectionInterfaceContactBlockingAdaptor::RequestBlockedContactsContextPtr &context);

Implementations should call MethodInvocationContext::setFinished (or setFinishedWithError accordingly) on the received context object once the method has finished processing.

List the contacts that are blocked.

Clients SHOULD allow a relatively long timeout for calls to this method, since on some protocols contact blocking is part of the contact list, which can take a significant time to retrieve.

Returns

      The blocked contacts’ handles, together with their identifiers.

## § BlockedContactsChanged

void Tp::Service::ConnectionInterfaceContactBlockingAdaptor::BlockedContactsChanged | ( | const Tp::HandleIdentifierMap & | blockedContacts,
|  | const Tp::HandleIdentifierMap & | unblockedContacts
| ) |  |

signal

Represents the exported D-Bus signal `BlockedContactsChanged` on this object.

Adaptees should export this signal as a Qt signal with the following signature: void blockedContactsChanged(const Tp::HandleIdentifierMap& blockedContacts, const Tp::HandleIdentifierMap& unblockedContacts);

The adaptee signal will be automatically relayed as a D-Bus signal once emitted.

Parameters

  blockedContacts

      Contacts added to the result of RequestBlockedContacts.

  unblockedContacts

      Contacts removed from the result of RequestBlockedContacts.